import java.io.*;

public class SLOG_Irec_min
{
    public short       bytesize;
    public short       rectype;
    public short       evttype;
    public SLOG_bebits bebits;
    public double      starttime;
    public double      duration;
    public short       node_id;
    public byte        cpu_id;
    public int         thread_id;
//    public long        where;

    public SLOG_Irec_min()
    {
        bytesize   = 0;
        evttype    = SLOG_Const.INVALID_short;
        rectype    = SLOG_Const.INVALID_short;
        bebits     = null;
        starttime  = SLOG_Const.INVALID_double;
        duration   = SLOG_Const.INVALID_double;
        node_id    = SLOG_Const.INVALID_short;
        cpu_id     = SLOG_Const.INVALID_byte;
        thread_id  = SLOG_Const.INVALID_int;
//        where      = SLOG_Const.NULL_fptr;
    }

    public SLOG_Irec_min( short   in_bytesize,
                          short   in_evttype,
                          short   in_rectype,
                          byte    in_bits_0,
                          byte    in_bits_1,
                          double  in_starttime,
                          double  in_duration,
                          short   in_node_id,
                          byte    in_cpu_id,
                          int     in_thread_id,
                          long    in_where )
    {
        bytesize   = in_bytesize;
        evttype    = in_evttype;
        rectype    = in_rectype;
        bebits     = new SLOG_bebits( in_bits_0, in_bits_1 );
        starttime  = in_starttime;
        duration   = in_duration;
        node_id    = in_node_id;
        cpu_id     = in_cpu_id;
        thread_id  = in_thread_id;
//        where      = in_where;
    }

    public SLOG_Irec_min( DataInputStream data_istm )
    throws IOException
    {
        this.ReadFromDataStream( data_istm );
    }

    public void ReadFromDataStream( DataInputStream data_istm )
    throws IOException
    {
        bytesize      = data_istm.readShort();
        evttype       = data_istm.readShort();
        rectype       = data_istm.readShort();
        bebits        = new SLOG_bebits( data_istm );
        starttime     = data_istm.readDouble();
        duration      = data_istm.readDouble();
        node_id       = data_istm.readShort();
        cpu_id        = data_istm.readByte();
        thread_id     = data_istm.readInt();
//        where         = data_istm.readLong();
    }

    public final int NbytesInFile()
    {
//        return( 29 + 1 + 8 );
        return( 30 );
    }

    public String toString()
    {
        StringBuffer representation = new StringBuffer( "[ " );
        representation.append(        bytesize  );
        representation.append( " " + evttype   );
        representation.append( " " + rectype   );
        representation.append( " " + bebits    );
        representation.append( " " + starttime );
        representation.append( " " + duration  );
        representation.append( " " + node_id   );
        representation.append( " " + cpu_id    );
        representation.append( " " + thread_id );
//        representation.append( " " + where );    
        representation.append( " ]" );
        return( representation.toString() );
    }
}
